#include <iostream>
#include <fstream>
#include <vector>
#include "myperm.h"

#define MAX	10

char get_elem_str(int n, int elem) {
	//std::cout << "\nELEM:" << elem << '\n';
	if (elem == 0)
		return '0';
	if (elem == n - 1)
		return '1';
	return char('a' + elem - 1);
}

void disp_setKKK(int n, int set) {
	std::cout << '{';
	bool first = true;
	for (int i = 0; i < n; i++) {
		if (set & (1 << i)) {
			if (first) {
				first = false;
			}
			else
				std::cout << ", ";
			std::cout << get_elem_str(n, i);
		}
	}
	std::cout << '}';
}

void disp_hypea(int n, int(&hypea)[MAX][MAX]) {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			disp_setKKK(n, hypea[i][j]);
			//std::cout << hypea[i][j];
			std::cout << ", ";
		}
		std::cout << '\n';
	}
}


struct t_perm {
	int n;
	int perm[MAX];

	t_perm() {}
	t_perm(int n, int (&perm)[MAX]) {
		this->n = n;
		for (int i =0 ; i < n; i++)
			this->perm[i] = perm[i];
	}

	t_perm(const t_perm &t) {
		n = t.n;
		for (int i = 0; i < t.n; i++)
			perm[i] = t.perm[i];
	}
};


void skip_ws(char **from) {
	char *pom = *from;

	while (*pom && (*pom == '\t' || *pom == ' '))
		pom++;

	*from = pom;
}

void parse_set(char **from) {
	char *pom = *from;

	skip_ws(&pom);
	if (*pom == '{') {
		pom++;
		while (*pom && *pom != '}') {
			skip_ws(&pom);
			if (*pom == '0' || *pom== '1' || (*pom-'a')<9) {
#if 0
				if (*pom == '0')
					set_outcome |= 1;
				else if (*pom == '1')
					set_outcome |= (1 << (n-1));
				else {
					set_outcome |= (1 << (*pom-'a'+1));
				}
#endif 
//				std::cout << "'" << *pom << "'\n";
				pom++;
			}
// ignoring empty sets
//			else {
//				std::cout << "Error - missing element\n";
//			}
			skip_ws(&pom);
			if (*pom && *pom != '}') {
				if (*pom != ',') {
					std::cout << "Error - missing ',', found "<< *pom << "\n";
				}
				else
					pom++;
			}
		}
	}
	else {
		std::cout << "Error - missing {\n";
	}

	if (*pom=='}')
		pom++;
	else {
		std::cout << "Error - missing }\n";
	}

	*from = pom;
}

bool parse_set(char **from, const int n, int &set) {
	char *pom = *from;
	int set_outcome = 0;

	skip_ws(&pom);
	if (*pom == '{') {
		pom++;
		while (*pom && *pom != '}') {
			skip_ws(&pom);
			if (*pom == '0' || *pom== '1' || (*pom-'a')<9) {
				if (*pom == '0')
					set_outcome |= 1;
				else if (*pom == '1')
					set_outcome |= (1 << (n-1));
				else {
					set_outcome |= (1 << (*pom-'a'+1));
				}
//				std::cout << "'" << *pom << "'\n";
				pom++;
			}
// ignoring empty sets
//			else {
//				std::cout << "Error - missing element\n";
//			}
			skip_ws(&pom);
			if (*pom && *pom != '}') {
				if (*pom != ',') {
					std::cout << "Error - missing ',', found "<< *pom << "\n";
					return false;
				}
				else
					pom++;
			}
		}
	}
	else {
		std::cout << "Error - missing {\n";
		return false;
	}

	if (*pom=='}')
		pom++;
	else {
		std::cout << "Error - missing }\n";
		return false;
	}

	*from = pom;
	set = set_outcome;
	return true;
}

int count_line(char *line) {
	char *pom  = line;
	int res_count = 0;

	while (*pom) {
		if (*pom == '{') {
			res_count++;	
			parse_set(&pom);
			skip_ws(&pom);
			if (*pom == ',')
				pom++;
		}
		pom++;
	}

	return res_count;
}

void parse_line(char *line) {
	char *pom  = line;

	while (*pom) {
		if (*pom == '{') {
			parse_set(&pom);
			skip_ws(&pom);
			if (*pom == ',')
				pom++;
		}
		pom++;
	}
}

bool is_less(int n, int (&hpea1)[MAX][MAX], int (&hpea2)[MAX][MAX]) {
	int i = 0, j;
	while (i < n) {
		j = 0;
		while (j < n) {
			if (hpea1[i][j] != hpea2[i][j]) {
				if (hpea1[i][j] < hpea2[i][j])
					return true;
				else
					return false;
			}
			j++;
		}
		i++;
	}
	return false;
}

int main(int argc, char **argv) {
	int hypea[MAX][MAX];
	int first_perm_vector = true;
	std::vector<t_perm> perms;

	if (argc < 2) {
		return 0;
	}

	std::fstream fil;

	fil.open(argv[1], std::fstream::in);

	if (fil.is_open()) {
		char buffer[512];

		bool is_first = true;
		int n;

		int hypea_line = 0;

		while (!fil.eof()) {
			fil.getline(buffer, 512);
//			std::cout << "Line: \"" << buffer << "\"\n";

			if (is_first) {
				/* count the size of the structure */

				n = count_line(buffer);
				std::cerr << "Size: " << n << '\n';				

				is_first = false;
			}
			
			if (hypea_line == n) {// skip --- 
				hypea_line = 0;

				if (first_perm_vector)
				{
				//	std::cout << "HERE\n";
					int perm[MAX];
					for (int i = 0; i < n; i++)
						perm[i] = i;

/*
					for (int i = 0; i < n; i++) {
						for (int j = 0; j < n; j++)
							std::cout << hypea[i][j];
						std::cout << '\n';
					}
*/
						
	
					while (next_perm(1, n - 2, perm)) {
/*
						for (int i = 0; i < n; i++)
							std::cout << perm[i];
						std::cout << '\n';
*/
						bool found = false;
						for (int i = 0; !found && (i < n); i++)
						for (int j = 0; j < n; j++) {
							if (hypea[i][j] && !hypea[perm[i]][perm[j]]) {
								found = true;
								break;
							}
							if ((hypea[i][j] & (1 << (n - 1))) && !(hypea[perm[i]][perm[j]] & (1 << (n - 1)))) {
								found = true;
								break;
								
	}
						}

						if (!found) {
							for (int i = 0; i < n; i++) 
								std::cerr << perm[i];
							std::cerr << '\n';

							perms.push_back(t_perm(n, perm));
						}
					}

					first_perm_vector= false;
				
					if (perms.empty()) {
						std::cerr << "There is no non-trivial permutation.\n";
					}
				}


				bool isl = false;
				for (std::vector<t_perm>::iterator it = perms.begin(); it != perms.end(); ++it) {
					//apply permutation
					int hyp_iso[MAX][MAX];

					for (int i = 0; i < n; i++)
					for (int j = 0; j < n; j++) {
						int set_outcome = 0;
						for (int k = 0; k < n; k++)
							if (hypea[i][j] & (1<< k))
								set_outcome |= (1 << it->perm[k]);
						hyp_iso[it->perm[i]][it->perm[j]] = set_outcome;

					}
#ifdef DEBUG
					std::cerr << "Applying perm: ";
					for (int i = 0 ; i < n; i++)
						std::cerr << it->perm[i];
					std::cerr << '\n';

					for (int i = 0; i < n; i++) {
						for (int j = 0; j < n; j++)
							std::cerr << hyp_iso[i][j] << ',';
						std::cerr << '\n';
					}
					
#endif

					if (is_less(n, hyp_iso, hypea)) {
						
#ifdef DEBUG
						std::cout << "Reducing ...\n";
						for (int i = 0; i < n; i++) {
							for (int j = 0; j < n; j++)
								std::cout << hyp_iso[i][j];
							std::cout << '\n';
						}
#endif
						isl = true;
						break;
					}
					

				}

				if (!isl) {
#if 0
					for (int i = 0; i < n; i++) {
						for (int j = 0; j < n; j++)
							std::cout << hypea[i][j] << ' ';
						std::cout << '\n';
					}
					std::cout << "---\n";
#endif
					disp_hypea(n, hypea);
					std::cout << "---\n";
				}

				continue;
			}

			char *pom = buffer;
			int j = 0;

			while (*pom) {
				if (*pom=='{') {
					int set;

					parse_set(&pom, n, set);
#ifdef DEBUG
					std::cout << set << ' ';
#endif

					hypea[hypea_line][j] = set;
					j++;
					
				}
				pom++;
			}

			hypea_line++;

#ifdef DEBUG
			std::cout << '\n';
#endif



/*
			char *pom = buffer;

			parse_set(&pom);

			if (fil.good()) {
				std::cout << buffer << '\n';
			}
*/

//			parse_line(buffer);
		}





		fil.close();
	}
	else {
		std::cout << "The file '" << argv[1] << "' cannot be opened for reading.\n";
	}

	return 0;
}
